let usage =
"Batch typing of a set of toplevel declarations, printing errors
The typing stops at the first error (use #fail to override)
Usage: batch <options> file"

let input = ref ""

let update_input i =
  if !input = "" then
    input := i
  else
    raise (Arg.Bad "File already specified")


let () =
  let annot = ref false
  and verbose = ref false
  in

  Arg.parse ([
    "-verbose", Arg.Set verbose,
            " Print the result of typing (equivalent to ocamlc -i)";
    "-annot", Arg.Set annot,
            " Annotate sub-expressions with their type (equivalent to -dtypes)";
  ] @ Options.common) update_input usage;

  try
    if !input <> "" then
      let ppf = if !verbose then Some Format.std_formatter else None in
      ignore (TypePhrases.parse_and_type_file ?ppf ~catch_errors:false
                ~annot:!annot !input);
  with Failure "TypePhrases" -> Printf.printf "\nTyping failed.\n"
;;
