open MLFSyntaxic
open MLFGraph


let v1 = v 1
let v2 = v 2
let v3 = v 3
let v4 = v 4
let v5 = v 5
let v6 = v 6

let arrows s = arrow s s


let l : polytype list = [
(* 0*) arrows int;
(* 1*) flex 1 (arrows v1);
(* 2*) flex 1 (flex 2 (arrow v1 v2));
(* 3*) flex 1 (arrows (arrows v1));
(* 4*) flex 1 (rigid 2 ~b:(arrows v1) (arrows v2)) (* Equivalent to 3 *);
(* 5*) flex 1 (rigid 2 ~b:(flex 3 (arrow v3 v1)) (arrow v2 v1));
(* 6*) flex 1 (arrow (arrows v1) v1);
(* 7*) flex 1 (flex 2 (flex 3 (arrow v1 (arrow v2 v3))));
(* 8*) flex 1 (arrow v1 (arrows v1));
(* 9*) flex 1 (rigid 2 ~b:(flex 3 (arrow v1 v3)) (arrows v2));

(* (v -> v) -> (v -> v) *)
(*10*) flex 1 ~b:(flex 2 (arrows v2)) (arrows v1);
(*11*) rigid 1 ~b:(flex 2 (arrows v2)) (arrows v1);
(*12*) flex 1 ~b:(rigid 2 (arrows v2)) (arrows v1);
(*13*) rigid 1 ~b:(rigid 2 (arrows v2)) (arrows v1);

(* u list -> v list *)
(*14*) flex 1 (arrows (list v1));
(*15*) flex 1 (flex 2 (arrow (list v1) (list v2)));

(*16*) flex 1 (rigid 2 ~b:(arrows v1) int) (* No polymorphism *);

       (* All equal, only v1 is bound *)
(*17*) flex 1 (flex 2 ~b:(arrows v1) (arrow (arrows v2) (arrows (arrows v1))));
(*18*) flex 1 (arrows (arrows (arrows v1)));
(*19*) flex 1 (flex 2 ~b:(arrows v1) (flex 3 ~b:(arrows v2) (arrows v3)));

(*20*) flex 1 ~b:(flex 2 ~b:(flex 3 (arrows v3)) (arrows v2)) (arrows v1);
(*21*) flex 1 ~b:(rigid 2 ~b:(flex 3 (arrows v3)) (arrows v2)) (arrows v1);
(*22*) flex 1 ~b:(flex 2 ~b:(rigid 3 (arrows v3)) (arrows v2)) (arrows v1);
(*23*) flex 1 ~b:(rigid 2 ~b:(rigid 3 (arrows v3)) (arrows v2)) (arrows v1);

(*24*) rigid 1 (arrows v1);
(*25*) rigid 1 ~b:(flex 2 (arrows v2)) (arrows v1);

(*26*) rigid 1 ~b:(flex 2 (t v2)) (arrows v1);
(*27*) rigid 1 ~b:(flex 2 (t v2)) (rigid 3 ~b:(flex 4 (t v4)) (arrow v1 v3));
(*28*) rigid 1 ~b:(flex 2 (t v2)) (rigid 3 ~b:(rigid 4 (t v4)) (arrow v1 v3));
(*29*) flex 1 (flex 2 ~b:(flex 3 (arrow v3 v1)) (arrow v1 v2));
(*30*) flex 1 ~b:(arrow int float) (arrow v1 v1);
(*31*) arrow (arrow int float) (arrow int float);
(*32*) flex 1 (flex 2 ~b:(flex 3 (arrow v3 v1)) (arrows v2));
(*33*) flex 1 ~b:(flex 2 ~b:(flex 4 (arrow int v4)) (flex 3 (arrow v2 v3))) (list v1);
(*34*) flex 1 ~b:(flex 2 ~b:(flex 4 (arrow int v4)) (flex 3 ~b:(flex 5 (flex 6 (arrow v5 v6))) (arrow v2 v3))) (list v1);
(*35*) flex 1 ~b:(flex 2 ~b:(flex 4 (arrow int v4)) (flex 3 ~b:(flex 5 (arrow int v5)) (arrow v2 v3))) (list v1);
(*36*) flex 1 ~b:(flex 2 ~b:(flex 4 (arrow int v4)) (arrow v2 v2)) (list v1);
(*37*) flex 1 ~b:(flex 2 (flex 3 ~b:(arrow int v2) (arrows v3))) (list v1);
(*38*) flex 1 ~b:(flex 2 (flex 4 (arrows (arrow int v4)))) (list v1);
(*39*) flex 1 ~b:(flex 2 (flex 4 (flex 5 ~b:int (arrows (arrow v5 v4))))) (list
v1);
(*40*) rigid 1 ~b:(flex 2 (flex 3 ~b:(arrow int v2) (arrows v3))) (list v1);
(*41*) rigid 1 ~b:(rigid 2 (flex 3 ~b:(arrow int v2) (arrows v3))) (list v1);
(*42*) rigid 1 ~b:(rigid 2 (flex 3 ~b:(arrow int float) (arrows v3))) (list v1);
(*43*) rigid 1 ~b:(flex 2 (flex 3 (arrow v2 v3))) (arrows v1);

]

open Translations

(*
let essai = List.fold_left (fun n t ->
    Printf.fprintf stderr "%d\n" n;
    ignore (syntaxic_to_graph t);
  n+1) 0 l
*)

let l' = List.map syntaxic_to_graph l

let l'' = List.map copy l'

(*

(*
let _ = assert (List.for_all Wf.correct l'')

let _ = List.iter2 (fun g1 g2 -> assert (equal_graphs g1 g2)) l' l''
*)


(*
let essai = List.fold_left (fun n t ->
    Printf.fprintf stderr "%d\n" n;
    ignore (graph_to_syntaxic t);
  n+1) 0 l'
*)

let l'' = List.map graph_to_syntaxic l'
let l''' = List.map syntaxic_to_graph l''

let _ =
  let g = List.nth l' (int_of_string Sys.argv.(1)) in
  print stdout g

*)


let g n = List.nth l' (int_of_string Sys.argv.(n))


open Printing

let _ =

if false then (
  for i = 0 to 43 do
    for j = 0 to 43 do
      let gi = copy (List.nth l' i)
      and gj = copy (List.nth l' j)
      in
      Utils.debug "P%d %d:\t " i j;
      try
        Unif.unif gi gj;
        if !Options.show_debug then assert (Wf.correct ~check_binding:true gi);
        Utils.debug "success\n"
      with Unif.UnifError e -> Utils.debug "%s\n" (Unif.print_unif_error e)
    done
  done;
  exit 0
)

else

  match Array.length Sys.argv with
  | 0 -> assert false
  | 1 -> print_list stdout node_display_helper l'
  | 2 -> print stdout node_display_helper (g 1)
  | _ ->
      let g1 = g 1 and g2 = copy (g 2) in
      Unif.unif_catch g1 g2;
      assert (Wf.correct ~check_binding:true g1);
      print stdout node_display_helper g1
