open Lexing

type 'a loc = {
  obj: 'a;
  loc: location;
}
and location = { loc_start: position; loc_end: position; loc_ghost: bool }

let loc_aux ghost p1 p2 =
  { loc_start = p1; loc_end = p2; loc_ghost = ghost }

let loc_ = loc_aux false

let dummy_loc = { loc_start = dummy_pos; loc_end = dummy_pos; loc_ghost = true }

let loc ?(ghost=false) e p1 p2 = { obj = e; loc = loc_aux ghost p1 p2}
let noloc e = { obj = e ; loc = loc_aux true dummy_pos dummy_pos }

let curr_loc lexbuf = {
  loc_start = lexbuf.lex_start_p;
  loc_end = lexbuf.lex_curr_p;
  loc_ghost = false
};;


let join l1 l2 = loc_aux (l1.loc_ghost || l2.loc_ghost) l1.loc_start l2.loc_end
